{% extends "base.html" %}
{% block static %}
  {% load static %}
  <link rel="stylesheet" type="text/css" href="{% static 'style/app.css' %}">
  <link rel="stylesheet" type="text/css" href="{% static 'style/group.css' %}">
{% endblock %}
{% block title %}Strapper - {{ application.descriptive_name }}{% endblock %}
{% block content %}
  {% if status != 200 %}
    <main>
      <h1>Status: {{ status }}</h1>
      <p>{{ message }}</p>
    </main>
  {% else %}
    <!-- App delete confirmation modal -->
    <div class="modal fade" id="deleteModal" tabindex="-1" aria-labelledby="deleteModalLabel" aria-hidden="true">
      <div class="modal-dialog modal-dialog-centered modal-dialog-scrollable">
        <div class="modal-content">
          <div class="modal-header">
            <h1 class="modal-title fs-5" id="deleteModalLabel"></h1>
            <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
          </div>
          <div class="modal-body">
            <label class="modal-body-text mb-1"></label>
            <input class="form-control" type="text">
          </div>
          <div class="modal-footer">
            <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
            <a href='#' class="btn btn-danger disabled delete-modal-confirm-btn">Confirm</a>
          </div>
        </div>
      </div>
    </div>

    <!-- Group delete confirmation modal -->
    {% for group in groups %}
      {% include 'modals/group_delete.html' %}
    {% endfor %}

    <!-- Conflicting apps when creating/editing groups modal -->
    <div class="modal fade" id="groupFormAppConflictModal" tabindex="-1" aria-hidden="true">
      <div class="modal-dialog modal-dialog-centered modal-dialog-scrollable">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title">Group already exists</h5>
            <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
          </div>
          <div class="modal-body">
            ...
          </div>
          <div class="modal-footer">
            <button type="button" class="btn btn-primary" data-bs-dismiss="modal">Understood</button>
          </div>
        </div>
      </div>
    </div>

    <!-- Add existing groups to an app modal -->
    <div class="modal fade add-groups-to-app-modal" id="addGroupsToAppModal-{{ application.identifier }}" data-app-id="{{ application.identifier }}" tabindex="-1" aria-hidden="true">
      <div class="modal-dialog modal-dialog-centered modal-dialog-scrollable">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title">Add existing groups to app {{ application.descriptive_name }}</h5>
            <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
          </div>
          <div class="modal-body">
            <p class="fs-6 fst-italic helper-text">Click on a group to select/deselect that group</p>
            <form class="group-showcase" action="/group/add_groups_to_app/{{ application.identifier }}/" method="post">
              {% csrf_token %}
              {% for group in owned_groups %}
                {% if group not in groups %}
                  {% if group.name not in application.group_names %}
                    {% with modal=1 %}
                      {% include "cards/group.html" %}
                    {% endwith %}
                  {% endif %}
                {% endif %}
              {% endfor %}
              <input class="group-field d-none" name="group_field" type="text">
              <div class="d-flex justify-content-end">
                <button type="button" class="btn btn-secondary ms-auto mt-3 me-2" data-bs-dismiss="modal">Cancel</button>
                <button type="submit" class="btn btn-danger mt-3 add-btn disabled">Add</button>
              </div>
            </form>
          </div>
        </div>
      </div>
    </div>

    <!-- Container deletion modal -->
    {% for container in containers %}
      {% include "modals/container_delete.html" %}
    {% endfor %}

    <!-- Harbor instructions modal -->
    {% if application.harborproject %}
      {% include "modals/harbor_instructions.html" %}
    {% endif %}

    {% if user_role == 'owner' or user_role == 'editor' %}
      <!-- K8s resources quota request form modal -->
      {% include "modals/k8s_resources_request_form.html" %}

      <!-- K8s resources quota request canceling confirmation modal -->
      {% include "modals/k8s_resources_request_cancel.html" %}
    {% endif %}

    <main>
      <!-- General configurations made by admin -->
      <input id="reserved-app-names" type="hidden" value="{{ general_config.reserved_app_names }}">
      <input id="unknown-criticality" type="hidden" value="{% if harbor_config.unknown_criticality %}{{ harbor_config.unknown_criticality }}{% else %}High{% endif %}">

      <!-- App information used by Javascript -->
      <input id="app-id" type="hidden" value="{{ application.identifier }}">
      <input id="scan-containers-url" type="hidden" value="{% url 'scan_containers_app' identifier=application.identifier %}">

      <div class="app-manager-panel" id="{{ application.identifier }}-panel">
        <!-- Panel navbar -->
        <ul class="nav nav-tabs" id="myTab" role="tablist">
          <li class="nav-item" role="presentation">
            <button class="nav-link {% if not active_tab %}active{% endif %}" data-bs-toggle="tab" data-bs-target="#{{ application.identifier }}-general-config-tab-pane" type="button" role="tab" aria-controls="{{ application.identifier }}-general-config-tab-pane" aria-selected="true">General Configurations</button>
          </li>
          <li class="nav-item" role="presentation">
            <button class="nav-link {% if active_tab == 'containers' %}active{% endif %}" data-bs-toggle="tab" data-bs-target="#{{ application.identifier }}-containers-tab-pane" type="button" role="tab" aria-controls="{{ application.identifier }}-containers-tab-pane" aria-selected="true">Containers</button>
          </li>
          <li class="nav-item" role="presentation">
            <button class="nav-link {% if active_tab == 'groups' %}active{% endif %}" data-bs-toggle="tab" data-bs-target="#{{ application.identifier }}-groups-tab-pane" type="button" role="tab" aria-controls="{{ application.identifier }}-groups-tab-pane" aria-selected="true">Groups</button>
          </li>
          <li class="nav-item" role="presentation">
            <button class="nav-link {% if active_tab == 'manage' %}active{% endif %}" data-bs-toggle="tab" data-bs-target="#{{ application.identifier }}-manage-tab-pane" type="button" role="tab" aria-controls="{{ application.identifier }}-manage-tab-pane" aria-selected="true">Manage app</button>
          </li>
        </ul>

        <!-- Display -->
        <div class="tab-content app-display" id="myTabContent">
          <!-- General config tab -->
          <div class="tab-pane fade {% if not active_tab %}show active{% endif %}" id="{{ application.identifier }}-general-config-tab-pane" role="tabpanel" aria-labelledby="{{ application.identifier }}-general-config-tab-pane" tabindex="0">
            <div class="row">
              <div class="col-12 col-lg-7">
                {% include 'components/app_summary.html' %}
                <div class="app-modal app-edit-form" id="app-edit-form-{{application.identifier}}" data-app-id="{{application.identifier}}">
                  <div class="app-modal-header bg-dark">Edit <span class="fw-semibold">{{application.descriptive_name}}</span></div>
                  <div class="app-modal-body">
                    {% include 'forms/config_app.html' %}
                  </div>
                </div>

                <div class="mt-3">
                  {% include 'components/app_k8s.html' %}
                </div>
              </div>
              <!-- App status -->
              <div class="col-12 col-lg-5 pe-lg-5 mt-3 mt-lg-0">
                {% include 'components/app_deployment.html' %}
                {% include 'components/harbor_project.html' %}
              </div>
            </div>
          </div>

          <!-- Containers tab -->
          <div class="tab-pane fade {% if active_tab == 'containers' %}show active{% endif %}" id="{{ application.identifier }}-containers-tab-pane" role="tabpanel" aria-labelledby="{{ application.identifier }}-containers-tab" tabindex="0">
            <div class="row">
              <div class="col-12 col-lg-7">
                {% if not application.harborproject %}
                  <div class="alert alert-warning no-harbor-project-warning-{{ application.identifier }}" role="alert">
                    <h4 class="alert-heading">No image registry found</h4>
                    <p class="mb-0">You need to have an image registry to create containers for this app. An image registry is where your containers are stored. Please click on the <strong>"Create project"</strong> button in the <strong>Image registry</strong> panel in the bottom right corner to create one right now! After that, you can start creating containers.</p>
                  </div>
                {% endif %}
                {% if not application.port %}
                  <div class="alert alert-warning no-harbor-project-warning-{{ application.identifier }}" role="alert">
                    <h4 class="alert-heading">No main container found</h4>
                    <p class="mb-0">You need exactly one main container to deploy the app. Click "edit" on one of the containers, check "Set this container as the main container" and submit.</p>
                  </div>
                {% endif %}
                <div class="app-containers-display app-containers-display-{{ application.identifier }} {% if not application.harborproject %}d-none{% endif %}">
                  {% if user_role == 'owner' or user_role == 'editor' %}
                    <label class="app-container-btn create">+ Create a container</label>
                  {% endif %}
                  <div class="app-container create-form container-form">
                    {% include "forms/config_container.html" %}
                  </div>
                  {% if application.container_set.count == 0 %}
                    <p class="no-container-text text-center mt-5">No container found. Please create at least one container to start deploying app.</p>
                  {% else %}
                    <div class="app-containers-holder">
                      {% for container in application.container_set.all %}
                        {% if container.is_main %}
                          <p class="text-primary mt-4 mb-1">Primary container: This container port {{ container.port }} will be exposed for external traffic.</p>
                        {% endif %}
                        <div class="app-container {% if container.is_main %}border border-primary border-2{% endif %}" id="app-container-{{ container.id }}" data-scan-report-url="{% url 'scan_report_container' identifier=application.identifier container_id=container.id %}">
                          <!-- Container scanning status -->
                          <!-- Loading -->
                          <div class="scan-container-loading-text d-flex flex-row gap-2 mb-4">
                            <div class="spinner-border text-primary" role="status">
                              <span class="visually-hidden">Loading...</span>
                            </div>
                            <span class="my-auto">Scanning for vulnerabilities...</span>
                          </div>
                          <!-- Scan failed -->
                          <p class="scan-container-failed-text text-danger d-none">
                            <i class="fa-solid fa-circle-exclamation me-2"></i>
                            <span>Failed to scan for container's vulnerabilities. </span>
                            <a href="#" class="container-rescan-btn" data-container-id="{{ container.id }}" data-scan-url="{% url 'scan_container' identifier=application.identifier container_id=container.id %}">Retry</a>
                          </p>
                          <!-- Scan succeeds and display result. This text is manipulated by Javascript -->
                          <div class="scan-container-status-text d-none mb-2"></div>

                          <!-- Container info -->
                          <div class="row mb-2">
                            <div class="col-4 fw-semibold">Image</div>
                            <div class="col-8 container-image">{{ container }}</div>
                          </div>
                          <div class="row mb-2">
                            <div class="col-4 fw-semibold">Exposed port</div>
                            <div class="col-8 container-port">{{ container.port }}</div>
                          </div>
                          <div class="row mb-2">
                            <div class="col-4 fw-semibold">Runtime command</div>
                            {% if container.command %}
                            <pre class="col-8 container-command"><code>{{ container.command }}</code></pre>
                            {% else %}
                              <div class="col-8 container-command">{{ container.command }}</div>
                            {% endif %}
                          </div>
                          <div class="row">
                            <div class="col-4 fw-semibold">Environment variables</div>
                            {% load replace %}
                            {% if container.environment_variables %}
                              <div class="col-8"><pre class="mt-1 container-environment-variables"><code>{{ container.environment_variables|replace:"==|=" }}</code></pre></div>
                            {% else %}
                              <div class="col-8"><span class="mt-1 container-environment-variables">{{ container.environment_variables }}</span></div>
                            {% endif %}
                          </div>

                          {% if user_role == 'owner' or user_role == 'editor' %}
                            <div class="app-modal-btn-container">
                              <button id="container-delete-modal-btn-{{ container.id }}" type="button" class="btn btn-outline-danger btn-sm delete-btn" data-bs-toggle="modal" data-bs-target="#containerDeleteModal-{{ container.id }}">Delete</button>
                              <button type="button" class="btn btn-outline-primary btn-sm edit-btn" data-container-id="{{ container.id }}">Edit</button>
                            </div>
                          {% endif %}
                        </div>
                        <div class="app-container edit-form container-form {% if container.is_main %}border border-primary border-2{% endif %}" id="app-container-form-{{ container.id }}">
                          {% include "forms/config_container.html" %}
                        </div>
                      {% endfor %}
                    </div>
                  {% endif %}
                </div>
              </div>

              <!-- App status -->
              <div class="col-12 col-lg-5 pe-lg-5 mt-3 mt-lg-0">
                {% include 'components/app_deployment.html' %}
                {% include 'components/harbor_project.html' %}
              </div>
            </div>
          </div>

          <!-- Groups tab -->
          <div class="tab-pane fade {% if active_tab == 'groups' %}show active{% endif %}" id="{{ application.identifier }}-groups-tab-pane" role="tabpanel" aria-labelledby="{{ application.identifier }}-groups-tab" tabindex="0">
            <div class="row">
              <div class="col-12 col-lg-7">
                {% include 'components/app_groups.html' %}
              </div>

              <!-- App status -->
              <div class="col-12 col-lg-5 pe-lg-5 mt-3 mt-lg-0">
                {% include 'components/app_deployment.html' %}
                {% include 'components/harbor_project.html' %}
              </div>
            </div>
          </div>

          <!-- Manage app tab -->
          <div class="tab-pane fade {% if active_tab == 'manage' %}show active{% endif %}" id="{{ application.identifier }}-manage-tab-pane" role="tabpanel" aria-labelledby="{{ application.identifier }}-manage-tab" tabindex="0">
            <div class="row">
              <div class="col-12 col-lg-7">
                {% include 'components/access_manager.html' %}

                {% if user_role == 'owner' %}
                  <div class="mt-4">
                    <h3>Delete application</h3>
                    <p>Remove this app configuration from Strapper. <strong>Note: Can only be done once all app resources are destroyed and only the app's owner has the right to delete the app.</strong></p>
                    <button
                      type="button"
                      class="btn btn-danger {% if application.deployment and application.deployment.is_stoppable %}disabled{% endif %} app-delete-btn"
                      data-identifier="{{ application.identifier }}"
                      data-name="{{ application.descriptive_name }}"
                      data-bs-toggle="modal" data-bs-target="#deleteModal"
                    >Delete app</button>
                  </div>
                {% endif %}
              </div>

              <!-- App status -->
              <div class="col-12 col-lg-5 pe-lg-5 mt-3 mt-lg-0">
                {% include 'components/app_deployment.html' %}
                {% include 'components/harbor_project.html' %}
              </div>
            </div>
          </div>
        </div>
      </div>
    </main>
  {% endif %}
{% endblock %}
{% block script %}
  {% load static %}
  <script src="{% static 'js/app.js' %}" type="module"></script>
{% endblock %}
